commit 84e2023455a0180c9b6420bac5bdeec0041529b0
Author: Michael Eager <eager@eagercon.com>
Date:   Fri Sep 19 18:53:28 2025

    [MicroBlaze][PR target/118280] Fix __atomic_test_and_set
    
    Atomic support enhanced to fix existing atomic_compare_and_swapsi pattern
    to handle side effects; new patterns atomic_fetch_op and atomic_test_and_set
    added. As MicroBlaze has no QImode test/set instruction, use shift magic
    to implement atomic_test_and_set.
    
            PR target/118280
    gcc/
            * config/microblaze/iterators.md: New.
            * config/microblaze/microblaze-protos.h: Add
            microblaze_subword_address.
            * config/microblaze/microblaze.cc: Ditto.
            * config/microblaze/microblaze.md: constants: Add UNSPECV_CAS_BOOL,
            UNSPECV_CAS_MEM, UNSPECV_CAS_VAL, UNSPECV_ATOMIC_FETCH_OP
            type: add atomic
            * config/microblaze/sync.md: Add atomic_fetch_<atomic_optab>si
            atomic_test_and_set
    
    Signed-off-by: Kirk Meyer <kirk.meyer@sencore.com>
    Signed-off-by: David Holsgrove <david.holsgrove@xilinx.com>
    Signed-off-by: Gopi Kumar Bulusu <gopi@sankhya.com>
    Signed-off-by: Michael Eager <eager@eagercon.com>

diff --git a/gcc/config/microblaze/microblaze-protos.h b/gcc/config/microblaze/microblaze-protos.h
index 90b79cfe716..1cee0b3096c 100644
--- a/gcc/config/microblaze/microblaze-protos.h
+++ b/gcc/config/microblaze/microblaze-protos.h
@@ -62,6 +62,7 @@ extern int symbol_mentioned_p (rtx);
 extern int label_mentioned_p (rtx);
 extern bool microblaze_cannot_force_const_mem (machine_mode, rtx);
 extern void microblaze_eh_return (rtx op0);
+extern void microblaze_subword_address (rtx, rtx *, rtx *);
 #endif  /* RTX_CODE */
 
 /* Declare functions in microblaze-c.cc.  */
diff --git a/gcc/config/microblaze/microblaze.cc b/gcc/config/microblaze/microblaze.cc
index 4b7f0a1a5e0..78b9428ef3b 100644
--- a/gcc/config/microblaze/microblaze.cc
+++ b/gcc/config/microblaze/microblaze.cc
@@ -1300,6 +1300,34 @@ microblaze_expand_block_move (rtx dest, rtx src, rtx length, rtx align_rtx)
   return false;
 }
 
+/* Compute memory address *aligned_mem and corresponding shift value (*shift)
+   from a QImode memory reference MEM */
+void
+microblaze_subword_address (rtx mem, rtx *aligned_mem, rtx *shift)
+{
+  /* Align the memory address to a word.  */
+  rtx addr = force_reg (Pmode, XEXP (mem, 0));
+
+  rtx addr_mask = gen_int_mode (-4, Pmode);
+
+  rtx aligned_addr = gen_reg_rtx (Pmode);
+
+  emit_move_insn (aligned_addr,  gen_rtx_AND (Pmode, addr, addr_mask));
+
+  *aligned_mem = change_address (mem, SImode, aligned_addr);
+
+  /* Calculate the shift amount.  */
+  emit_move_insn (*shift, gen_rtx_AND (SImode, addr, gen_int_mode (3, SImode)));
+
+  if (TARGET_LITTLE_ENDIAN == 0) {
+    emit_move_insn (*shift,
+		    gen_rtx_MINUS (SImode, gen_int_mode (3, SImode), *shift));
+  }
+
+  emit_move_insn (*shift, gen_rtx_ASHIFT (SImode, *shift,
+					  gen_int_mode (3, SImode)));
+}
+
 static bool
 microblaze_rtx_costs (rtx x, machine_mode mode, int outer_code ATTRIBUTE_UNUSED,
 		      int opno ATTRIBUTE_UNUSED, int *total,
